<?php

namespace Litecms\Withdrwalbonus\Policies;

use Litepie\User\Contracts\UserPolicy;
use Litecms\Withdrwalbonus\Models\Withdrwalbonus;

class WithdrwalbonusPolicy
{

    /**
     * Determine if the given user can view the withdrwalbonus.
     *
     * @param UserPolicy $user
     * @param Withdrwalbonus $withdrwalbonus
     *
     * @return bool
     */
    public function view(UserPolicy $user, Withdrwalbonus $withdrwalbonus)
    {
        if ($user->canDo('withdrwalbonus.withdrwalbonus.view') && $user->isAdmin()) {
            return true;
        }

        return $withdrwalbonus->user_id == user_id() && $withdrwalbonus->user_type == user_type();
    }

    /**
     * Determine if the given user can create a withdrwalbonus.
     *
     * @param UserPolicy $user
     * @param Withdrwalbonus $withdrwalbonus
     *
     * @return bool
     */
    public function create(UserPolicy $user)
    {
        return  $user->canDo('withdrwalbonus.withdrwalbonus.create');
    }

    /**
     * Determine if the given user can update the given withdrwalbonus.
     *
     * @param UserPolicy $user
     * @param Withdrwalbonus $withdrwalbonus
     *
     * @return bool
     */
    public function update(UserPolicy $user, Withdrwalbonus $withdrwalbonus)
    {
        if ($user->canDo('withdrwalbonus.withdrwalbonus.edit') && $user->isAdmin()) {
            return true;
        }

        return $withdrwalbonus->user_id == user_id() && $withdrwalbonus->user_type == user_type();
    }

    /**
     * Determine if the given user can delete the given withdrwalbonus.
     *
     * @param UserPolicy $user
     * @param Withdrwalbonus $withdrwalbonus
     *
     * @return bool
     */
    public function destroy(UserPolicy $user, Withdrwalbonus $withdrwalbonus)
    {
        return $withdrwalbonus->user_id == user_id() && $withdrwalbonus->user_type == user_type();
    }

    /**
     * Determine if the given user can verify the given withdrwalbonus.
     *
     * @param UserPolicy $user
     * @param Withdrwalbonus $withdrwalbonus
     *
     * @return bool
     */
    public function verify(UserPolicy $user, Withdrwalbonus $withdrwalbonus)
    {
        if ($user->canDo('withdrwalbonus.withdrwalbonus.verify')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given withdrwalbonus.
     *
     * @param UserPolicy $user
     * @param Withdrwalbonus $withdrwalbonus
     *
     * @return bool
     */
    public function approve(UserPolicy $user, Withdrwalbonus $withdrwalbonus)
    {
        if ($user->canDo('withdrwalbonus.withdrwalbonus.approve')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the user can perform a given action ve.
     *
     * @param [type] $user    [description]
     * @param [type] $ability [description]
     *
     * @return [type] [description]
     */
    public function before($user, $ability)
    {
        if ($user->isSuperuser()) {
            return true;
        }
    }
}
