<?php

namespace Litecms\Withdrwalbonus\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class WithdrwalbonusTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Withdrwalbonus\Models\Withdrwalbonus $withdrwalbonus)
    {
        return [
            'id'                => $withdrwalbonus->getRouteKey(),
            'key'               => [
                'public'    => $withdrwalbonus->getPublicKey(),
                'route'     => $withdrwalbonus->getRouteKey(),
            ], 
            'with_level_1'      => $withdrwalbonus->with_level_1,
            'with_level_2'      => $withdrwalbonus->with_level_2,
            'with_level_3'      => $withdrwalbonus->with_level_3,
            'with_level_4'      => $withdrwalbonus->with_level_4,
            'url'               => [
                'public'    => trans_url('withdrwalbonus/'.$withdrwalbonus->getPublicKey()),
                'user'      => guard_url('withdrwalbonus/withdrwalbonus/'.$withdrwalbonus->getRouteKey()),
            ], 
            'status'            => trans('app.'.$withdrwalbonus->status),
            'created_at'        => format_date($withdrwalbonus->created_at),
            'updated_at'        => format_date($withdrwalbonus->updated_at),
        ];
    }
}